-- ObjEu Interface Class Animal
-- Adapted from the Polymorphism section in Visual Basic Books Online.

-- Include ObjEu Library in top-level class
include ObjEu.e

without warning

procedure Move(sequence Animal, integer distance)
    -- abstract
end procedure

procedure Bite(sequence Animal, object what)
    -- abstract
end procedure

-- Register the animal class as top-level class
RegisterClass("Animal", -1, -1, "")

-- Register Methods
-- Use -1 for callback argument to enforce abstract
RegisterMethod("Animal", "Move", -1)
RegisterMethod("Animal", "Bite", -1)