-- Demo of ObjEu Library
-- Adapted from the Polymorphism section in Visual Basic Books Online.

include get.e
include trex.cls
include flea.cls

without warning

with trace

-- To step through code uncomment next line
-- trace(1)

procedure GetFood(sequence Critter, sequence food)
    integer distance

    distance = 10

    -- Code to calculate distance to food (omitted).
    method(Critter, "Move", {distance})
    method(Critter, "Bite", {food})

end procedure

-- Press down arrow to step through code
integer key

-- Create a flea object named fl
new ( "Flea", "fl", {} )

-- Create a tyrannosaur object named ty
new ( "Tyrannosaur", "ty", {} )

-- Create an Animal object named anim
new ( "Animal", "anim", {} )

-- First give the flea a shot.
setObject("anim", "fl")
method("anim", "Bite", {"ty"}) -- Flea bites dinosaur.

-- Now the Tyrannosaur gets a turn.
setObject("anim", "ty")
method("anim", "Bite", {"fl"}) -- Dinosaur bites flea.

key = wait_key()

-- Passing object references to procedures

-- Flea dines on dinosaur
GetFood("fl", "ty")

-- And vice versa
GetFood("ty", "fl")

