-- ObjEu Class Flea
-- Adapted from the Polymorphism section in Visual Basic Books Online.

-- Include animal class
include animal.cls

without warning

-- Must implement Animal's Move and Bite methods

procedure Animal_Move(sequence Flea, integer distance)
    -- (Code to jump some number of inches omitted.)
    puts(1, "Flea moved.\n")
end procedure

procedure Animal_Bite(sequence Flea, sequence what)
    -- (Code to suck blood omitted.)
    puts(1, "Flea bit a " & TypeName(what) & "\n")
end procedure

-- Make sure to register Flea as a subclass of Animal
RegisterClass( "Flea", -1, -1, "Animal")

-- Override Animal's Move and Bite methods
OverrideMethod( "Flea", "Move", routine_id("Animal_Move") )
OverrideMethod( "Flea", "Bite", routine_id("Animal_Bite") )