-- ObjEu Class MenuItem

with trace

include ObjEu.e
include dos32lib.e

function getCurrentWindow()
    sequence obj
    
    obj = {}
    
    for a = 1 to length(objects) do
        obj = objects[a][OBJNAME]
        if equal(TypeName(obj), "MenuItem") = 1then
            if equal(getProp(obj, "ID"), currentCtl) = 1 then
                return obj
                exit    
            end if
        end if
    end for
    
    return obj
    
end function               

procedure onClick_MenuItem()
    sequence obj
    
    obj = getCurrentWindow()

    RaiseEvent(obj, "Click", {obj})
            
end procedure               

function MenuItem_Create(sequence Item, sequence text, integer parent)
    integer id
    
    id = create( MenuItem, text, parent, 0,0,0,0,0 )
    
    setProp(Item, "ID", id)
    setProp(Item, "Caption", text)
    
    onClick[id] = routine_id("onClick_MenuItem")
    
    return 1
    
end function

RegisterClass("MenuItem", routine_id("MenuItem_Create"), -1, "")

RegisterProp("MenuItem", "ID", -2, -2, 0)
RegisterProp("MenuItem", "Caption", -2, -2, "")


