with trace

global sequence DYNAMIC_INCLUDE_FILES

DYNAMIC_INCLUDE_FILES = {}

global procedure MakeOxeFile(sequence Name, sequence File, sequence MainProc)
    integer fn
    sequence txt, FileName
    
    FileName = File[1..length(File)-2] & "oxe"
    
    txt = "include " & File & 10 & 10 & 
          "function Main(sequence Obj)" & 10 &
          "    " & MainProc & "()" & 10 &
          "    return 1" & 10 & 
          "end function" & 10 & 10 &
          "RegisterClass( \"" & Name & "\", routine_id(\"Main\"), -1, \"\")" & 10 &
          "AddToProgramMenu( \"" & Name & "\" )"

    fn = open(FileName, "w")
    
    puts(fn, txt)
    
    close(fn)
                                                                                   
end procedure                                                                

global function getProgramList()
    integer fn
    sequence res
    
    fn = open("programs.lst", "r")
    
    if fn = -1 then
        return {}    
    end if    
    
    res = get(fn)
    
    close(fn)
    
    return res[2]
    
end function             

global procedure saveProgramList()
    integer fn
    
    fn = open("programs.lst", "w")
    
    print(fn, DYNAMIC_INCLUDE_FILES)
    
    close(fn)
    
end procedure

procedure mnuPrograms_Click(sequence MenuClicked)
    new( MenuClicked, "Program" & (length(objects) + 1), {} )
end procedure                

global procedure AddToProgramMenu(sequence class)
    Programs = append(Programs, class)
end procedure                         

DYNAMIC_INCLUDE_FILES = getProgramList()

